#include "hardware.h"

//the larger this number, the more likely your robot will drive straight
#define threshold 8

// Initialise the hardware
void appInitHardware(void) {
	initHardware();


}
// Initialise the software
TICK_COUNT appInitSoftware(TICK_COUNT loopStart){
	return 0;
}
// This is the main loop
TICK_COUNT appControl(LOOP_COUNT loopCount, TICK_COUNT loopStart) {

	// -------- Start Analogue Input-------
	// Read the Analogue Input and store results
	uint16_t left_sensorval = a2dConvert10bit(left_sensor);
	// Dump out the value
	//rprintf("left_sensor: %d\n",left_sensorval);
	// -------- End   Analogue Input-------

	// -------- Start Analogue Input-------
	// Read the Analogue Input and store results
	uint16_t right_sensorval = a2dConvert10bit(right_sensor);
	// Dump out the value
	//rprintf("right_sensor: %d\n",right_sensorval);
	// -------- End   Analogue Input-------

	// -------- Start Actuators -------
	// To control your.motors/servos then see actuators.h in the manual
	// To retrieve the required speed of left_motor use:
	// DRIVE_SPEED speed=act_getSpeed(left_motor);
	// To set the required speed of left_motor use:
	// act_setSpeed(left_motor,speed);
	// -------- End   Actuators -------

	if(left_sensorval > right_sensorval && (left_sensorval - right_sensorval) > threshold)
	{
		// go left
		act_setSpeed(&left_motor,DRIVE_SPEED_MIN);
		act_setSpeed(&right_motor,DRIVE_SPEED_MAX);
	}
	else if(right_sensorval > left_sensorval && (right_sensorval - left_sensorval) > threshold)
	{
		// go right
		act_setSpeed(&left_motor,DRIVE_SPEED_MAX);
		act_setSpeed(&right_motor,DRIVE_SPEED_MIN);
	}
	else
	{
		// Go forwards
		act_setSpeed(&left_motor,DRIVE_SPEED_MAX);
		act_setSpeed(&right_motor,DRIVE_SPEED_MAX);
	}
	return 20000; // wait for 20ms to stop crazy oscillations

}
