/*
		This file has been auto-generated by WebbotLib tools V1.1
				** DO NOT MODIFY BY HAND **
*/
#ifndef _HARDWARE_H_
#define _HARDWARE_H_

#if !defined (_LIB_HARDWARE_C_)
#define BUILDING_LIBRARY
#define _LIB_HARDWARE_C_
#endif

#ifndef F_CPU
#warning No CPU speed specified - assuming running at 1000000
#define F_CPU 1000000
#endif

#if F_CPU != 1000000
# warning "Board runs at 1000000 but you have defined a different value"
#endif

#if defined (__AVR_ATmega8__)
#else
#	error You must set the device to the ATmega8
#endif

#define FLASH_SIZE 8192
#define RAM_SIZE 1024
#define EEPROM_SIZE 512

// Include library files
#include <libdefs.h>
#include <timer.h>
#include <a2d.h>
#include <rprintf.h>
#include <led.h>
#include <avr/eeprom.h>
#include <motorPWM.h>

// ----------- Define the used pins ------------
extern IOPin PROGMEM _B0;
extern IOPin PROGMEM _B1;
extern IOPin PROGMEM _B2;
extern IOPin PROGMEM _B3;
extern IOPin PROGMEM _D4;
extern IOPin PROGMEM _D5;
extern IOPin PROGMEM _D6;
extern IOPin PROGMEM _D7;
#define B0 &_B0
#define B1 &_B1
#define B2 &_B2
#define B3 &_B3
#define D4 &_D4
#define D5 &_D5
#define D6 &_D6
#define D7 &_D7
// ----------- Start Timer Definition -------------

// Define timer 0

// Define timer 1
extern TimerCompare PROGMEM __timer1Compare[];
#define TIMER1_COMPAREA &__timer1Compare[0]
#define TIMER1_COMPAREB &__timer1Compare[1]

// Define timer 2
extern TimerCompare PROGMEM __timer2Compare[];
#define TIMER2_COMPAREA &__timer2Compare[0]

// Create table of timers
extern const PROGMEM Timer PROGMEM pgm_Timers[];
extern const uint8_t NUMBER_OF_TIMERS;
#define TIMER0 &pgm_Timers[0]
#define TIMER1 &pgm_Timers[1]
#define TIMER2 &pgm_Timers[2]
// ----------- End Timer Definition -------------


#ifndef BUILDING_LIBRARY
// Type of interrupt handler to use for timer interrupts.
// Do not change unless you know what you're doing.
#ifndef TIMER_INTERRUPT_HANDLER
#define TIMER_INTERRUPT_HANDLER	ISR
#endif
// ----------- Start Timer Definition -------------

// Define timer 0
static TimerData __timer0_data = MAKE_TIMER_DATA(0);
// Timer has no compare channels
#define __timer0Compare null

// Define timer 1
static TimerData __timer1_data = MAKE_TIMER_DATA(0);
static TimerDataCompare __timer1CompareA_data = MAKE_TIMER_COMPARE_DATA();
static TimerDataCompare __timer1CompareB_data = MAKE_TIMER_COMPARE_DATA();
TimerCompare PROGMEM __timer1Compare[] = {
	MAKE_TIMER_COMPARE(__timer1CompareA_data,1,TIMSK,OCIE1A,OCR1A,TIFR,OCF1A,TCCR1A,COM1A0,B1),
	MAKE_TIMER_COMPARE(__timer1CompareB_data,1,TIMSK,OCIE1B,OCR1B,TIFR,OCF1B,TCCR1A,COM1B0,B2)
};

// Define timer 2
static TimerData __timer2_data = MAKE_TIMER_DATA(0);
static TimerDataCompare __timer2CompareA_data = MAKE_TIMER_COMPARE_DATA();
TimerCompare PROGMEM __timer2Compare[] = {
	MAKE_TIMER_COMPARE(__timer2CompareA_data,2,TIMSK,OCIE2,OCR2,TIFR,OCF2,TCCR2,COM20,B3)
};

// Create table of timers
const PROGMEM Timer PROGMEM pgm_Timers[] = {
	MAKE_TIMER(__timer0_data,TCNT0,TCCR0,false,false,TIMER_NO_MODES,
		UNUSED_PORT,0,UNUSED_PORT,0,UNUSED_PORT,0,UNUSED_PORT,0,
		__timer0Compare,TIMSK,TOIE0,TIFR,TOV0,UNUSED_PORT,UNUSED_PORT,0,UNUSED_PORT,0,UNUSED_PORT,0,null),
	MAKE_TIMER(__timer1_data,TCNT1,TCCR1B,true,false,TIMER_ALL_MODES,
		TCCR1A,WGM10,TCCR1A,WGM11,TCCR1B,WGM12,TCCR1B,WGM13,
		__timer1Compare,TIMSK,TOIE1,TIFR,TOV1,ICR1,TIMSK,TICIE1,TIFR,ICF1,TCCR1B,ICES1,B0),
	MAKE_TIMER(__timer2_data,TCNT2,TCCR2,false,true,TIMER_2BIT_MODES,
		TCCR2,WGM20,TCCR2,WGM21,UNUSED_PORT,0,UNUSED_PORT,0,
		__timer2Compare,TIMSK,TOIE2,TIFR,TOV2,UNUSED_PORT,UNUSED_PORT,0,UNUSED_PORT,0,UNUSED_PORT,0,null)
};
const uint8_t NUMBER_OF_TIMERS =  (sizeof(pgm_Timers)/sizeof(Timer));
// ----------- End Timer Definition -------------

#endif

// ----------- Define the ADC channels ----------
#define ADC0 ADC_NUMBER_TO_CHANNEL(0)
#define ADC1 ADC_NUMBER_TO_CHANNEL(1)
#define ADC2 ADC_NUMBER_TO_CHANNEL(2)
#define ADC3 ADC_NUMBER_TO_CHANNEL(3)
#define ADC4 ADC_NUMBER_TO_CHANNEL(4)
#define ADC5 ADC_NUMBER_TO_CHANNEL(5)
extern const uint8_t NUM_ADC_CHANNELS;

// ----------- My devices -----------------------
extern MOTOR left_motor;
extern MOTOR right_motor;
extern MOTOR_DRIVER l293d;
#define left_sensor ADC5
#define right_sensor ADC4

void initHardware(void);
#endif

// undefine all ports so the user cannot change them directly
#undef PORTB
#undef DDRB
#undef PINB
#undef PORTC
#undef DDRC
#undef PINC
#undef PORTD
#undef DDRD
#undef PIND

// Undefine timer registers to stop users changing them
#undef TCNT0
#undef TCCR0
#undef TCNT1
#undef TCCR1B
#undef OCR1A
#undef OCR1B
#undef TCNT2
#undef TCCR2
#undef OCR2
