
// Include hardware info for this device	
#include <avr/io.h>

		
#if defined(__AVR_ATmega8__)
// There are no Timer0 compare channels
// There is only one Timer2 compare channel
#  define TIMER2_COMPA_vect TIMER2_COMP_vect
// Map the UART vectors
#  define USART0_RX_vect USART_RXC_vect
#  define USART0_TX_vect USART_TXC_vect
#else
#  error "Processor mismatch in utilities.xsl"
#endif
			
#include "../hardware.h"
#include <timer.h>
#include <errors.h>
// Variable used by main library to link in this module
uint8_t PROGMEM _timer_compare_error = TIMER_COMPARE_CALLBACK_EXISTS;
// The dummy routine used to denote that the compare is in use
// Only ever called from here but not static to avoid unused warnings
void nullTimerCompareCallback(const TimerCompare *timer_compare, void* data){}

// TIMER1_COMPAREA is in use
static void __attribute__ ((constructor)) init_TIMER1_COMPAREA(void){
	TimerDataCompare* data = compareGetData(TIMER1_COMPAREA);
	data->compare_callback = &nullTimerCompareCallback;
}

// TIMER1_COMPAREB is in use
static void __attribute__ ((constructor)) init_TIMER1_COMPAREB(void){
	TimerDataCompare* data = compareGetData(TIMER1_COMPAREB);
	data->compare_callback = &nullTimerCompareCallback;
}

// TIMER2_COMPAREA is in use
static void __attribute__ ((constructor)) init_TIMER2_COMPAREA(void){
	TimerDataCompare* data = compareGetData(TIMER2_COMPAREA);
	data->compare_callback = &nullTimerCompareCallback;
}

